<template>
  <div class="search">
    <CoscineHeadline :headline="$t('page.search.title')" />
    <div class="v_gapped_container">
      <b-row id="mainRow" class="m-0">
        <!-- Sidebar -->
        <Sidebar v-model="category" :is-loading="resultsViewLoading" />

        <b-col
          ref="rightCol"
          sm="10"
          align-self="stretch"
          class="v_gapped_container"
        >
          <!-- Search Bar Fields -->
          <b-row id="searchBarContainer" align-content="center">
            <b-col id="searchField" align-self="start" class="ps-0">
              <b-form-input
                v-model="searchText"
                :debounce="1000"
                :placeholder="$t('page.search.search')"
              />
            </b-col>
            <!-- All Projects -->
            <b-col id="selectProjCol" sm="2" align-self="center" class="ps-0">
              <b-form-select
                v-model="selectedProject"
                :options="allProjectsOptions"
                :disabled="
                  allProjectsOptions ? allProjectsOptions.length < 1 : true
                "
                @update:model-value="triggerSearch"
              >
                <template #first>
                  <b-form-select-option :value="null">
                    {{ $t("page.search.allProjects") }}
                  </b-form-select-option>
                </template>
              </b-form-select>
            </b-col>
            <!-- All Resources -->
            <b-col id="selectResCol" sm="2" align-self="center" class="ps-0">
              <b-form-select
                v-model="selectedResource"
                :options="projectResourcesOptions"
                :disabled="
                  projectResourcesOptions
                    ? projectResourcesOptions.length < 1
                    : true
                "
                @update:model-value="triggerSearch"
              >
                <template #first>
                  <b-form-select-option :value="null">
                    {{ $t("page.search.allResources") }}
                  </b-form-select-option>
                </template>
              </b-form-select>
            </b-col>
            <b-col align-self="center" class="text-end p-0 col-auto">
              <b-button-group>
                <b-button
                  id="searchButton"
                  variant="primary"
                  :disabled="resultsViewLoading"
                  @click="triggerSearch()"
                >
                  {{ $t("page.search.search") }}
                  <b-spinner v-if="resultsViewLoading" variant="secondary" />
                </b-button>
              </b-button-group>
            </b-col>
          </b-row>

          <!-- Category & Direction Sorting-->
          <b-row
            id="filterContainer"
            align-self="center"
            class="my-2 rounded bg-secondary-subtle"
            style="min-height: 37px"
          >
            <b-col sm="12" align-self="center" class="text-end p-0">
              <b-button-group size="sm" class="bg-body">
                <b-dropdown
                  :text="
                    $t(
                      `page.search.${sortingDefinition.category.toLowerCase()}`,
                    )
                  "
                  split-variant="outline-secondary"
                  variant="secondary"
                >
                  <b-dropdown-item
                    :disabled="resultsViewLoading"
                    @click="sortingDefinition.category = 'Score'"
                  >
                    {{ $t("page.search.score") }}
                  </b-dropdown-item>
                  <b-dropdown-item
                    :disabled="resultsViewLoading"
                    @click="sortingDefinition.category = 'Date'"
                  >
                    {{ $t("page.search.date") }}
                  </b-dropdown-item>
                  <b-dropdown-item
                    :disabled="resultsViewLoading"
                    @click="sortingDefinition.category = 'Name'"
                  >
                    {{ $t("page.search.name") }}
                  </b-dropdown-item>
                </b-dropdown>

                <b-button
                  variant="outline-secondary"
                  :disabled="resultsViewLoading"
                  @click="setSortingDirection()"
                >
                  <i-bi-sort-up v-if="sortingDefinition.direction === 'Asc'" />
                  <i-bi-sort-down v-else />
                </b-button>
              </b-button-group>
            </b-col>
          </b-row>

          <!-- Results View -->
          <b-row id="resultsViewContainer" align-self="end">
            <b-card class="w-100 h-100">
              <b-placeholder-wrapper :loading="resultsViewLoading">
                <template #loading>
                  <div
                    v-for="(entry, index) in 3"
                    :key="index"
                    class="p-2 border-top"
                    style="height: 105px"
                  >
                    <b-placeholder size="lg" width="30%" class="m-2 mb-3" />
                    <b-placeholder size="lg" width="95%" class="m-2" />
                    <b-placeholder size="lg" width="40%" class="m-2" />
                  </div>
                </template>
                <b-table
                  id="resultsView"
                  :items="searchResults"
                  :fields="resultsViewFields"
                  :per-page="pagination ? pagination.PageSize : 0"
                  :current-page="1"
                  thead-class="d-none"
                  style="min-height: 100%"
                  small
                  hover
                  sticky-header
                  show-empty
                >
                  <template #cell(type)="data">
                    <MetadataResult
                      :result="data.item"
                      :all-projects="allProjects"
                      :query="searchText"
                    />
                  </template>

                  <template #empty>
                    <h6 class="text-center">
                      {{ $t("page.search.emptySearch") }}
                    </h6>
                  </template>

                  <template #custom-foot="foot">
                    <!-- Show footer if there are results and only on the last page -->
                    <div
                      v-if="
                        foot.items.length > 0 &&
                        pagination &&
                        !pagination.HasNext
                      "
                      class="p-2 text-center text-muted border-top"
                    >
                      {{ $t("page.search.endSearchResults") }}
                    </div>
                  </template>
                </b-table>
              </b-placeholder-wrapper>
            </b-card>
          </b-row>
        </b-col>
      </b-row>

      <!-- Pagination -->
      <b-row
        v-if="!resultsViewLoading"
        class="text-end"
        align-v="center"
        no-gutters
      >
        <b-col align-self="center" class="p-0" />
        <b-col align-self="center" class="p-0">
          <b-pagination
            id="pagination"
            v-model="selectedPage"
            :total-rows="pagination ? pagination.TotalCount : 0"
            :per-page="pagination ? pagination.PageSize : 0"
            aria-controls="resultsView"
            align="center"
          />
        </b-col>
        <b-col align-self="center" class="p-0">
          <b-form-select
            v-model="paginationPageSize"
            :options="paginationPerPageOptions"
            style="max-width: 5rem"
          />
        </b-col>
      </b-row>
    </div>
  </div>
</template>

<script lang="ts">
import MetadataResult from "./components/MetadataResult.vue";
import Sidebar from "./components/Sidebar.vue";

// import the store for current module
import useSearchStore from "../store";
// import the project store
import useProjectStore from "@/modules/project/store";
// import the resource store
import useResourceStore from "@/modules/resource/store";

import {
  CategoryFilters,
  SearchResultCategories,
  SearchResultDirections,
} from "../types";
import type { ResourceDto } from "@coscine/api-client/dist/types/Coscine.Api";
import type {
  SearchCategoryType,
  SearchResultDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import type { Pagination, SearchResultSorting } from "../types";
import type { ProjectDto } from "@coscine/api-client/dist/types/Coscine.Api";
import type { LocationQueryRaw } from "vue-router";

export default defineComponent({
  components: {
    MetadataResult,
    Sidebar,
  },
  setup() {
    const searchStore = useSearchStore();
    const projectStore = useProjectStore();
    const resourceStore = useResourceStore();

    return { searchStore, projectStore, resourceStore };
  },

  data() {
    return {
      searchText: "",
      selectedProject: null as null | ProjectDto,
      selectedResource: null as null | ResourceDto,

      projectResources: null as ResourceDto[] | null,
      projectSubProjects: null as ProjectDto[] | null,

      filterTags: [],

      resultsViewFields: ["type"],
      resultsViewLoading: true,

      paginationPerPageOptions: [5, 10, 20, 50],
      selectedPage: 1,
      paginationPageSize: 10,

      // Controls the "orderBy" query param that is being set in two parts
      sortingDefinition: {
        category: SearchResultCategories.Score,
        direction: SearchResultDirections.Desc,
      } as SearchResultSorting,
      category: CategoryFilters.None as SearchCategoryType,
    };
  },
  computed: {
    allProjects(): ProjectDto[] {
      return this.projectStore.allProjects ?? [];
    },
    allResources(): ResourceDto[] | null {
      return null;
    },
    allProjectsOptions(): {
      value: ProjectDto;
      text: string | null | undefined;
    }[] {
      if (this.allProjects) {
        return this.allProjects.map((project) => {
          return {
            value: project,
            text: project.displayName,
          };
        });
      }
      return [];
    },
    projectResourcesOptions(): {
      value: ResourceDto;
      text: string | null | undefined;
    }[] {
      let projectResourcesOptions: ResourceDto[] = [];
      if (this.projectResources) {
        projectResourcesOptions = this.projectResources;
      } else if (this.resourceStore.allResources != null) {
        projectResourcesOptions = this.resourceStore.allResources;
      }
      return projectResourcesOptions.map((resource) => {
        return {
          value: resource,
          text: resource.displayName,
        };
      });
    },
    paginationTotalRows(): number {
      if (this.searchStore.pagination?.TotalCount) {
        return this.searchStore.pagination.TotalCount;
      } else return 0;
    },
    pagination(): Pagination | null {
      return this.searchStore.pagination;
    },
    resultsForTable(): SearchResultDto[] {
      const result: SearchResultDto[] = [];
      if (this.searchResults) {
        result.push(
          ...this.searchResults.filter((item) => this.isFilteredItem(item)),
        );
      }
      return result;
    },
    searchResults(): SearchResultDto[] {
      return this.searchStore.searchResults ?? [];
    },
    orderBy() {
      return `${this.sortingDefinition.category}_${this.sortingDefinition.direction}`;
    },
  },

  watch: {
    searchText() {
      // Trigger API call to search on orderBy change
      this.triggerSearch();
    },

    selectedProject() {
      this.selectedResource = null;
      this.projectResources = null;
      this.projectSubProjects = [];

      this.retrieveResources();
      this.retrieveSubProjects();
    },

    sortingDefinition: {
      handler() {
        // Trigger API call to search on orderBy change
        this.triggerSearch();
      },
      // Required to detect changes in the params of the object
      deep: true,
    },

    category() {
      // Trigger API call to search on category change
      this.triggerSearch();
    },

    selectedPage() {
      // Trigger API call to search on page change
      this.triggerSearch();
    },

    paginationPageSize() {
      // Trigger API call to search on page size change
      this.triggerSearch();
    },
  },

  async mounted() {
    this.searchText = (this.$route.query["q"] as string) ?? "";
    this.category =
      (this.$route.query["filter"] as SearchCategoryType) ??
      CategoryFilters.None;
    this.getOrderByFromRoute();
    await Promise.all([this.retrieveResources(), this.retrieveSubProjects()]);
  },

  methods: {
    isFilteredItem(searchResult: SearchResultDto): boolean {
      const resultType = searchResult.type?.split("#").at(1);
      if (resultType === "Metadata" || resultType === "Resource") {
        return !this.selectedResource ||
          !this.selectedResource.id ||
          searchResult.uri?.includes(this.selectedResource.id)
          ? true
          : false;
      } else if (resultType === "Project") {
        // No filter since the API already filtered them
        return true;
      }

      return true;
    },
    getOrderByFromRoute() {
      const orderBy = this.$route.query["orderBy"] as string | undefined;
      if (orderBy) {
        const [category, direction] = orderBy.split("_", 2);
        if (Object.keys(SearchResultCategories).includes(category))
          this.sortingDefinition.category =
            category as SearchResultSorting["category"];

        if (Object.keys(SearchResultDirections).includes(direction)) {
          this.sortingDefinition.direction =
            direction as SearchResultSorting["direction"];
        }
      }
    },
    async triggerSearch() {
      await this.queryData(
        this.searchText,
        this.selectedPage,
        this.paginationPageSize,
        this.category,
        this.orderBy,
      );
    },
    async queryData(
      query: string,
      pageNumber: number,
      pageSize: number,
      category: SearchCategoryType | undefined = undefined,
      order: string | undefined = undefined,
    ) {
      this.resultsViewLoading = true;

      // Generate the router query based on filters
      let q: LocationQueryRaw = { q: query };
      if (category && category !== CategoryFilters.None)
        q = Object.assign(q, { filter: category });
      if (order) q = Object.assign(q, { orderBy: order });

      this.$router.push({
        name: "search",
        query: q,
      });

      // attach search query, resulting in "/search?q=<searchTerm>

      await this.searchStore.retrieveSearchResults(
        query,
        pageNumber,
        pageSize,
        this.selectedProject,
        category,
        order,
      );
      this.resultsViewLoading = false;
    },
    async retrieveResources() {
      if (this.selectedProject) {
        this.projectResources = await this.projectStore.getResourcesForProject(
          this.selectedProject,
        );
        this.selectedResource = null;
      } else {
        this.projectResources = null;
      }
    },
    async retrieveSubProjects() {
      if (this.selectedProject) {
        this.projectSubProjects = this.projectStore.currentSubProjects;
      } else {
        this.projectSubProjects = [];
      }
    },
    setSortingDirection() {
      if (this.sortingDefinition.direction === "Desc")
        this.sortingDefinition.direction = "Asc";
      else this.sortingDefinition.direction = "Desc";
    },
  },
});
</script>

<style scoped>
#mainRow {
  /* this style stretches the page vertically to fit the screen:
    - pagination row height = 54px
    - mainRow <-> container-fluid = 102px
    - mainRow <-> bottom = 62px
  */
  height: calc(100vh - var(--sidebar-offset-top) - 102px - 62px);
}
#pagination {
  margin-top: 0.5rem;
  margin-bottom: 0.5rem;
}
#resultsViewContainer {
  /* this style stretches the results table vertically 
    - resultsViewContainer <-> mainRow = 91px
    - first row = 38px
    - second row = 37px
    - gap = 2*0.5rem
  */
  height: calc(100% - 38px - 37px - 2 * 0.5rem);
}
.search :deep(.card-body),
.search :deep(.card) {
  padding: 0rem;
}
button :deep(span.spinner-border) {
  height: 15px;
  width: 15px;
  margin-right: 4px;
}
</style>
